diff -urN libgnomedb/libgnomedb/gnome-db-raw-grid.c libgnomedbnew/libgnomedb/gnome-db-raw-grid.c
--- libgnomedb/libgnomedb/gnome-db-raw-grid.c	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/gnome-db-raw-grid.c	2009-04-19 18:38:14.000000000 +0200
@@ -1,6 +1,6 @@
 /* gnome-db-raw-grid.c
  *
- * Copyright (C) 2002 - 2008 Vivien Malerba
+ * Copyright (C) 2002 - 2009 Vivien Malerba
  *
  * This Library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Library General Public License as
@@ -50,7 +50,7 @@
 static void proxy_sample_changed_cb (GdaDataProxy *proxy, gint sample_start, gint sample_end, GnomeDbRawGrid *grid);
 static void proxy_row_updated_cb (GdaDataProxy *proxy, gint proxy_row, GnomeDbRawGrid *grid);
 static void proxy_reset_cb (GdaDataProxy *proxy, GnomeDbRawGrid *grid);
-static void paramlist_public_data_changed_cb (GdaSet *paramlist, GnomeDbRawGrid *grid);
+static void paramlist_public_data_changed_cb (GnomeDbSet *paramlist, GnomeDbRawGrid *grid);
 static void paramlist_param_attr_changed_cb (GdaSet *paramlist, GdaHolder *param, 
 					     const gchar *att_name, const GValue *att_value, GnomeDbRawGrid *grid);
 static GError *iter_validate_set_cb (GdaDataModelIter *iter, GnomeDbRawGrid *grid);
@@ -69,28 +69,33 @@
 static void            gnome_db_raw_grid_widget_set_gda_model             (GnomeDbDataWidget *iface, GdaDataModel *model);
 static gboolean        gnome_db_raw_grid_widget_set_write_mode (GnomeDbDataWidget *iface, GnomeDbDataWidgetWriteMode mode);
 static GnomeDbDataWidgetWriteMode gnome_db_raw_grid_widget_get_write_mode (GnomeDbDataWidget *iface);
+static void            gnome_db_raw_grid_set_data_layout (GnomeDbDataWidget  *iface, gpointer  data);
 
 typedef struct {
-	GdaSetGroup     *group;
+	GnomeDbSetGroup *group;
 	GtkCellRenderer *data_cell;
 	GtkCellRenderer *info_cell;
 	gboolean         info_shown;
 	gboolean         data_locked; /* TRUE if no modification allowed on that column */
+        gchar           *tooltip_text;
 } ColumnData;
 
 #define COLUMN_DATA(x) ((ColumnData *)(x))
 
-static ColumnData *get_column_data (GnomeDbRawGrid *grid, GdaSetGroup *group);
+static ColumnData *get_column_data (GnomeDbRawGrid *grid, GnomeDbSetGroup *group);
 
 struct _GnomeDbRawGridPriv
 {
 	GdaDataModel               *data_model;  /* data model provided by set_model() */
 	GdaDataModelIter           *iter;        /* iterator for @store, used for its structure */
+	GnomeDbSet                 *iter_info;
 	GnomeDbDataStore           *store;       /* GtkTreeModel interface, using @proxy */
 	GdaDataProxy               *proxy;       /* proxy data model, proxying @data_model */
 
 	GSList                     *columns_data; /* list of ColumnData */
 
+	GSList                     *reordered_indexes;  /* Indexes of the reordered columns. */
+
 	gboolean                    default_show_info_cell;
 	gboolean                    default_show_global_actions;
 
@@ -123,6 +128,7 @@
 {
         PROP_0,
 	PROP_MODEL,
+	PROP_DATA_LAYOUT,
 	PROP_INFO_CELL_VISIBLE,
 	PROP_GLOBAL_ACTIONS_VISIBLE
 };
@@ -215,6 +221,7 @@
 	iface->set_gda_model = gnome_db_raw_grid_widget_set_gda_model;
 	iface->set_write_mode = gnome_db_raw_grid_widget_set_write_mode;
 	iface->get_write_mode = gnome_db_raw_grid_widget_get_write_mode;	
+	iface->set_data_layout = gnome_db_raw_grid_set_data_layout;
 }
 
 static void
@@ -256,6 +263,11 @@
 	g_object_class_install_property (object_class, PROP_MODEL,
                                          g_param_spec_object ("model", _("Data to display"), NULL, GDA_TYPE_DATA_MODEL,
 							      G_PARAM_READABLE | G_PARAM_WRITABLE));
+	
+	g_object_class_install_property (object_class, PROP_DATA_LAYOUT,
+					 g_param_spec_pointer ("data_layout", 
+							       _("Pointer to an XML data layout specification"), NULL,
+							       G_PARAM_WRITABLE));
 	g_object_class_install_property (object_class, PROP_INFO_CELL_VISIBLE,
                                          g_param_spec_boolean ("info_cell_visible", NULL, _("Info cell visible"), FALSE,
                                                                G_PARAM_READABLE | G_PARAM_WRITABLE));
@@ -358,6 +370,340 @@
 }
 
 static void
+load_xml_data_layout_item (GnomeDbRawGrid  *grid,
+			   xmlNodePtr       node,
+			   gpointer         data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (grid && GNOME_DB_IS_RAW_GRID (grid));
+
+	gchar *name = NULL;
+	gint sequence = 0;
+	gboolean editable = FALSE;
+	gboolean sort_ascending = FALSE;
+
+	xmlChar *str;
+	str = xmlGetProp (node, "name");
+	if (str) {
+		name = g_strdup (str);
+		g_print ("name: %s\n", str);
+		xmlFree (str);
+	}
+
+	/* str = xmlGetProp (node, "relationship"); */
+	/* if (str) { */
+	/* 	g_print ("relationship: %s\n", str); */
+	/* 	xmlFree (str); */
+	/* } */
+
+	/* str = xmlGetProp (node, "related_relationship"); */
+	/* if (str) { */
+	/* 	g_print ("related_relationship: %s\n", str); */
+	/* 	xmlFree (str); */
+	/* } */
+
+	str = xmlGetProp (node, "sequence");
+	if (str) {
+		sequence = atoi (str);
+		g_print ("sequence: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "editable");
+	if (str) {
+		editable = (*str == 't' || *str == 'T') ? TRUE : FALSE;
+		g_print ("editable: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "sort_ascending");
+	if (str) {
+		sort_ascending = (*str == 't' || *str == 'T') ? TRUE : FALSE;
+		g_print ("sort_ascending: %s\n", str);
+		xmlFree (str);
+	}
+
+	/* GSList *slist = grid->priv->set->holders; */
+	/* while (slist != NULL) { */
+	/* 	GdaHolder *holder = slist->data; */
+	/* 	g_print ("SET HOLDER=%s\n", gda_holder_get_id (holder)); */
+	/* 	slist = g_slist_next (slist); */
+	/* } */
+
+	//GdaHolder *holder = gda_set_get_holder (grid->priv->set, name);
+	GdaHolder *holder = gda_set_get_holder (GDA_SET (grid->priv->iter), name);
+	g_return_if_fail (holder != NULL);
+
+	gint index = g_slist_index (GDA_SET (grid->priv->iter)->holders, holder);
+
+	grid->priv->reordered_indexes = g_slist_insert (grid->priv->reordered_indexes,
+						     GINT_TO_POINTER(index),
+						     sequence - 1);
+
+        GnomeDbSetGroup *group = _gnome_db_set_get_group (grid->priv->iter_info, holder);
+        if (!group)
+		return;
+
+        ColumnData *column_data = get_column_data (grid, group);
+        g_return_if_fail (column_data);
+
+        column_data->tooltip_text = g_strdup ((const gchar *) data);
+        //g_print ("*** %s\n", column_data->tooltip_text);
+
+	gint position = g_slist_index (GDA_SET (grid->priv->iter)->holders, holder);
+	GtkTreeViewColumn *column = gtk_tree_view_get_column (GTK_TREE_VIEW (grid), position);
+	g_return_if_fail (column != NULL);
+
+	// ((GdaDataSelect *) model)->prep_stmt
+	GdaDataModel *model = grid->priv->data_model;
+
+	const gchar *text = NULL;
+	if (GDA_IS_DATA_SELECT (model))
+		text = gda_utility_data_model_find_column_description (GDA_DATA_SELECT (model), name);
+	if (!text)
+		text = gda_holder_get_id (holder);
+
+	gtk_tree_view_column_set_title (column, text);
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		/* if (child->type == XML_ELEMENT_NODE && */
+		/*     !xmlStrcmp (child->name, (const xmlChar *) "formatting")) { */
+		/* } */
+
+		/* if (child->type == XML_ELEMENT_NODE && */
+		/*     !xmlStrcmp (child->name, (const xmlChar *) "title_custom")) { */
+		/* } */
+	}
+
+}
+
+static void
+load_xml_data_layout_group (GnomeDbRawGrid  *grid,
+			    xmlNodePtr       node,
+			    gpointer         data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (grid && GNOME_DB_IS_RAW_GRID (grid));
+
+	gchar *name = NULL;
+	gint sequence = 0;
+	gint columns_count = 1;
+	gchar *title = NULL;
+
+	xmlChar *str;
+	str = xmlGetProp (node, "name");
+	if (str) {
+		name = g_strdup (str);
+		g_print ("name: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "sequence");
+	if (str) {
+		sequence = atoi (str);
+		g_print ("sequence: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "columns_count");
+	if (str) {
+		columns_count = atoi (str);
+		g_print ("columns_count: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "title");
+	if (str) {
+		title = g_strdup (str);
+		g_print ("title: %s\n", str);
+		xmlFree (str);
+	}
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_group")) {
+			load_xml_data_layout_group (grid, child, data);
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_item")) {
+			load_xml_data_layout_item (grid, child, /* data *//* table */ title);
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_portal")) {
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_notebook")) {
+		}
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "trans_set")) {
+			/* load_xml_trans_set (grid, child, data); */
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_button")) {
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_item_groupby")) {
+		}
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_item_header")) {
+		}
+	}
+
+	g_free (name);
+	g_free (title);
+}
+
+static void
+load_xml_data_layout_groups (GnomeDbRawGrid  *grid,
+			     xmlNodePtr       node,
+			     gpointer         data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (grid && GNOME_DB_IS_RAW_GRID (grid));
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_group")) {
+			load_xml_data_layout_group (grid, child, /* data */ NULL);
+		}
+	}
+
+}
+
+static void
+load_xml_data_layout (GnomeDbRawGrid  *grid,
+		      xmlNodePtr       node,
+		      gpointer         data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (grid && GNOME_DB_IS_RAW_GRID (grid));
+
+	gchar *parent_table = NULL;
+	gchar *name = NULL;
+
+	xmlChar *str;
+	str = xmlGetProp (node, "parent_table");
+	if (str) {
+		parent_table = g_strdup (str);
+		g_print ("parent_table: %s\n", str);
+		xmlFree (str);
+	}
+
+	str = xmlGetProp (node, "name");
+	if (str) {
+		name = g_strdup (str);
+		g_print ("name: %s\n", str);
+		xmlFree (str);
+	}
+
+	// Don't recurse unnecessarily
+	gboolean retval = FALSE;
+	if (strcmp ((const gchar *) data, parent_table) != 0 ||
+	    strcmp ("list", name) != 0) {
+		retval = TRUE;
+	}
+	g_free (parent_table);
+	g_free (name);
+	if (retval)
+		return;
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_groups")) {
+			load_xml_data_layout_groups (grid, child, data);
+		}
+	}
+
+}
+
+static void
+load_xml_data_layouts (GnomeDbRawGrid  *grid,
+		       xmlNodePtr       node,
+		       gpointer         data)
+{
+	g_print ("%s:\n", __func__);
+	g_return_if_fail (grid && GNOME_DB_IS_RAW_GRID (grid));
+
+	xmlNodePtr child;
+	for (child = node->children; child != NULL; child = child->next) {
+
+		if (child->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (child->name, (const xmlChar *) "data_layout")) {
+			load_xml_data_layout (grid, child, data);
+		}
+
+	}
+
+}
+
+static gboolean
+gnome_db_raw_grid_query_tooltip (GtkWidget   *widget,
+				 gint         x,
+				 gint         y,
+				 gboolean     keyboard_tip,
+				 GtkTooltip  *tooltip,
+				 gpointer     data)
+{
+	GtkTreeView *tree_view = GTK_TREE_VIEW(widget);
+
+	if (!gtk_tree_view_get_tooltip_context (tree_view, &x, &y,
+						keyboard_tip,
+						NULL, NULL, NULL))
+		return FALSE;
+
+	gint position = 0;
+	guint col_x = 0;
+	GList *columns = gtk_tree_view_get_columns (tree_view), *list = columns;
+	while (list != NULL) {
+		GtkTreeViewColumn *column = list->data;
+		if (x >= col_x && x < (col_x + column->width)) {
+			break;
+		} else
+			col_x += column->width;
+		++position;
+		list = g_list_next (list);
+	}
+	if (list == NULL)
+		return FALSE;
+
+	GnomeDbRawGrid *grid = GNOME_DB_RAW_GRID(tree_view);
+	ColumnData *column_data = (ColumnData *)
+		(g_slist_nth (grid->priv->columns_data, position)->data);
+	g_return_val_if_fail (column_data, FALSE);
+
+	g_list_free (columns);
+
+	if (column_data->tooltip_text == NULL)
+		return FALSE;
+
+	gchar *markup = g_strdup_printf ("<i>%s</i> <b>%s</b>",
+					 _("Group:"), column_data->tooltip_text);
+	gtk_tooltip_set_markup (tooltip, markup);
+	g_free (markup);
+        /* GSList *slist = grid->priv->columns_data; */
+        /* while (slist) { */
+        /*         g_print ("--- %s\n", COLUMN_DATA (slist->data)->tooltip_text); */
+        /*         slist = g_slist_next (slist); */
+        /* } */
+
+	return TRUE;
+}
+
+static void
 gnome_db_raw_grid_set_property (GObject *object,
 				guint param_id,
 				const GValue *value,
@@ -368,64 +714,130 @@
         grid = GNOME_DB_RAW_GRID (object);
         if (grid->priv) {
                 switch (param_id) {
-		case PROP_MODEL:
-			{
-				GdaDataModel *model = GDA_DATA_MODEL (g_value_get_object (value));
-				if (model)
-					g_return_if_fail (GDA_IS_DATA_MODEL (model));
-	
-				gnome_db_raw_grid_clean (grid);
-				if (!model)
-					return;
-	
-				grid->priv->store = GNOME_DB_DATA_STORE (gnome_db_data_store_new (model));
-				grid->priv->proxy = gnome_db_data_store_get_proxy (grid->priv->store);
-				grid->priv->data_model = gda_data_proxy_get_proxied_model (grid->priv->proxy);
-				
-				g_object_ref (G_OBJECT (grid->priv->proxy));
-				g_signal_connect (grid->priv->proxy, "sample_changed",
-						  G_CALLBACK (proxy_sample_changed_cb), grid);
-				g_signal_connect (grid->priv->proxy, "row_updated",
-						  G_CALLBACK (proxy_row_updated_cb), grid);
-				g_signal_connect (grid->priv->proxy, "reset",
-						  G_CALLBACK (proxy_reset_cb), grid);
+		case PROP_MODEL: {
+			GdaDataModel *model = GDA_DATA_MODEL (g_value_get_object (value));
+			if (model)
+				g_return_if_fail (GDA_IS_DATA_MODEL (model));
+			
+			gnome_db_raw_grid_clean (grid);
+			if (!model)
+				return;
+			
+			grid->priv->store = GNOME_DB_DATA_STORE (gnome_db_data_store_new (model));
+			grid->priv->proxy = gnome_db_data_store_get_proxy (grid->priv->store);
+			grid->priv->data_model = gda_data_proxy_get_proxied_model (grid->priv->proxy);
+			
+			g_object_ref (G_OBJECT (grid->priv->proxy));
+			g_signal_connect (grid->priv->proxy, "sample_changed",
+					  G_CALLBACK (proxy_sample_changed_cb), grid);
+			g_signal_connect (grid->priv->proxy, "row_updated",
+					  G_CALLBACK (proxy_row_updated_cb), grid);
+			g_signal_connect (grid->priv->proxy, "reset",
+					  G_CALLBACK (proxy_reset_cb), grid);
 				
-				grid->priv->iter = gda_data_model_create_iter (GDA_DATA_MODEL (grid->priv->proxy));
+			grid->priv->iter = gda_data_model_create_iter (GDA_DATA_MODEL (grid->priv->proxy));
+			grid->priv->iter_info = gnome_db_set_new (GDA_SET (grid->priv->iter));
 				
-				g_signal_connect (grid->priv->iter, "public_data_changed",
-						  G_CALLBACK (paramlist_public_data_changed_cb), grid);
-				g_signal_connect (grid->priv->iter, "holder-attr-changed",
-						  G_CALLBACK (paramlist_param_attr_changed_cb), grid);
-
-				g_signal_connect (grid->priv->iter, "row_changed",
-						  G_CALLBACK (iter_row_changed_cb), grid);
-				g_signal_connect (grid->priv->iter, "validate-set",
-						  G_CALLBACK (iter_validate_set_cb), grid);
+			g_signal_connect (grid->priv->iter_info, "public_data_changed",
+					  G_CALLBACK (paramlist_public_data_changed_cb), grid);
+			g_signal_connect (grid->priv->iter, "holder-attr-changed",
+					  G_CALLBACK (paramlist_param_attr_changed_cb), grid);
+
+			g_signal_connect (grid->priv->iter, "row_changed",
+					  G_CALLBACK (iter_row_changed_cb), grid);
+			g_signal_connect (grid->priv->iter, "validate-set",
+					  G_CALLBACK (iter_validate_set_cb), grid);
 
-				gda_data_model_iter_invalidate_contents (grid->priv->iter);
+			gda_data_model_iter_invalidate_contents (grid->priv->iter);
 							
-				gtk_tree_view_set_model ((GtkTreeView *) grid, GTK_TREE_MODEL (grid->priv->store));
-				init_tree_view (grid);
+			gtk_tree_view_set_model ((GtkTreeView *) grid, GTK_TREE_MODEL (grid->priv->store));
+			init_tree_view (grid);
 	
-				g_signal_emit_by_name (object, "proxy_changed", grid->priv->proxy);
-				g_signal_emit_by_name (object, "iter_changed", grid->priv->iter);
+			g_signal_emit_by_name (object, "proxy_changed", grid->priv->proxy);
+			g_signal_emit_by_name (object, "iter_changed", grid->priv->iter);
 				
-				break;
-			}
+			break;
+		}
 				
-		case PROP_INFO_CELL_VISIBLE: 
-			{
-				GSList *list = grid->priv->columns_data;
-				gboolean show = g_value_get_boolean (value);
-				grid->priv->default_show_info_cell = show;
-	
-				while (list) {
-					COLUMN_DATA (list->data)->info_shown = show;
-					g_object_set (G_OBJECT (COLUMN_DATA (list->data)->info_cell), "visible", 
-						      show, NULL);
-					list = g_slist_next (list);
+		case PROP_DATA_LAYOUT: {
+			xmlNodePtr node = g_value_get_pointer (value);
+
+			xmlNodePtr child;
+			for (child = node->children; child != NULL; child = child->next) {
+
+				if (child->type == XML_ELEMENT_NODE &&
+				    !xmlStrcmp (child->name, (const xmlChar *) "data_layout_groups")) {
+					load_xml_data_layout_groups (grid, child, NULL);
+				}
+			}
+
+			if (grid->priv->reordered_indexes != NULL) {
+				g_print ("Loaded XML file, reinit interface\n");
+
+				GList *columns = gtk_tree_view_get_columns (GTK_TREE_VIEW(grid));
+
+				GtkTreeViewColumn *prev_column = NULL;
+				GSList *columns_data = NULL;
+
+				GSList *reordered_indexes = grid->priv->reordered_indexes;
+				while (reordered_indexes != NULL) {
+					gint position = GPOINTER_TO_INT(reordered_indexes->data);
+
+					GtkTreeViewColumn *column = GTK_TREE_VIEW_COLUMN
+						(g_list_nth (columns, position)->data);
+
+					gtk_tree_view_move_column_after (GTK_TREE_VIEW(grid),
+									 column, prev_column);
+					prev_column = column;
+
+					// Data columns are handled
+					ColumnData *column_data = (ColumnData *)
+						(g_slist_nth (grid->priv->columns_data, position)->data);
+					columns_data = g_slist_append (columns_data, column_data);
+
+					reordered_indexes = g_slist_next (reordered_indexes);
 				}
+				g_list_free (columns);
+
+				g_slist_free (grid->priv->columns_data);
+				grid->priv->columns_data = columns_data;
+
+				// Remove unnecessary columns according layout
+				columns = gtk_tree_view_get_columns (GTK_TREE_VIEW(grid));
+
+				gint num_columns = g_list_length (columns);
+				gint num_reordered_indexes = g_slist_length (grid->priv->reordered_indexes);
+				if (num_reordered_indexes < num_columns) {
+					gint i;
+					for (i = num_reordered_indexes; i < num_columns; ++i) {
+						GtkTreeViewColumn *column = GTK_TREE_VIEW_COLUMN
+							(g_list_nth (columns, i)->data);
+						gtk_tree_view_remove_column (GTK_TREE_VIEW(grid), column);
+					}
+				}
+				g_list_free (columns);
+
+				g_object_set (G_OBJECT(grid), "has-tooltip", TRUE, NULL);
+				g_signal_connect (G_OBJECT(grid), "query-tooltip",
+						  G_CALLBACK(gnome_db_raw_grid_query_tooltip), NULL);
+			}
+
+		}
+
+			break;
+				
+		case PROP_INFO_CELL_VISIBLE: {
+			GSList *list = grid->priv->columns_data;
+			gboolean show = g_value_get_boolean (value);
+			grid->priv->default_show_info_cell = show;
+	
+			while (list) {
+				COLUMN_DATA (list->data)->info_shown = show;
+				g_object_set (G_OBJECT (COLUMN_DATA (list->data)->info_cell), "visible", 
+					      show, NULL);
+				list = g_slist_next (list);
 			}
+		}
 			break;
 			
 		case PROP_GLOBAL_ACTIONS_VISIBLE:
@@ -558,16 +970,16 @@
 	tree_view = GTK_TREE_VIEW (grid);
 
 	/* Creation of the columns in the treeview, to fit the parameters in grid->priv->iter param list */
-	list = GDA_SET (grid->priv->iter)->groups_list;
-	i = 0;
-	while (list) {
+	for (i = 0, list = grid->priv->iter_info->groups_list;
+	     list;
+	     i++, list = list->next) {
 		GdaHolder *param;
-		GdaSetGroup *group;
+		GnomeDbSetGroup *group;
 		GtkTreeViewColumn *column;
 		GtkCellRenderer *renderer;
 		ColumnData *column_data;
 
-		group = GDA_SET_GROUP (list->data);
+		group = GNOME_DB_SET_GROUP (list->data);
 
 		/* update the list of columns data */
 		column_data = get_column_data (grid, group);
@@ -576,17 +988,18 @@
 			column_data->group = group;
 			column_data->info_shown = grid->priv->default_show_info_cell;
 			column_data->data_locked = FALSE;
+			column_data->tooltip_text = NULL;
 			grid->priv->columns_data = g_slist_append (grid->priv->columns_data, column_data);
 		}
 
 		/* create renderers */
-		if (group->nodes_source) {
+		if (group->source) {
 			/* parameters depending on a GdaDataModel */
 			gchar *title;
 			gboolean nullok = TRUE;
 			GSList *nodes;
 			
-			nodes = group->nodes;
+			nodes = group->group->nodes;
 			while (nodes && nullok) {
 				if (gda_holder_get_not_null (GDA_HOLDER (GDA_SET_NODE (nodes->data)->holder)))
 					nullok = FALSE;
@@ -594,11 +1007,11 @@
 			}
 			
 			/* determine title */
-			if (g_slist_length (group->nodes) == 1)
-				title = (gchar *) g_object_get_data (G_OBJECT (GDA_SET_NODE (group->nodes->data)->holder),
+			if (g_slist_length (group->group->nodes) == 1)
+				title = (gchar *) g_object_get_data (G_OBJECT (GDA_SET_NODE (group->group->nodes->data)->holder),
 								     "name");
 			else 
-				title = (gchar *) g_object_get_data (G_OBJECT (group->nodes_source->data_model),
+				title = (gchar *) g_object_get_data (G_OBJECT (group->group->nodes_source->data_model),
 								     "name");
 
 			if (title)
@@ -609,7 +1022,7 @@
 
 			/* FIXME: if nullok is FALSE, then set the column title in bold */
 
-			renderer = gnome_db_data_cell_renderer_combo_new (GDA_SET (grid->priv->iter), group->nodes_source);
+			renderer = gnome_db_data_cell_renderer_combo_new (grid->priv->iter_info, group->source);
 			column_data->data_cell = renderer;
 			gtk_tree_view_insert_column_with_data_func (tree_view, i, title, renderer,
 								    (GtkTreeCellDataFunc) cell_renderer_value_set_attributes, 
@@ -620,7 +1033,7 @@
 			g_signal_connect (G_OBJECT (renderer), "changed", 
 					  G_CALLBACK (data_cell_values_changed), grid);
 
-			g_object_set_data (G_OBJECT (column), "source", group->nodes_source);
+			g_object_set_data (G_OBJECT (column), "source", group->group->nodes_source);
 		}
 		else {
 			/* single direct parameter */
@@ -629,7 +1042,7 @@
 			const GValue *plugin_val;
 			gchar *title;
 			
-			param = GDA_HOLDER (GDA_SET_NODE (group->nodes->data)->holder);
+			param = GDA_HOLDER (GDA_SET_NODE (group->group->nodes->data)->holder);
 			g_type = gda_holder_get_g_type (param);
 
 			g_object_get (G_OBJECT (param), "name", &title, NULL);
@@ -667,8 +1080,8 @@
 		g_object_set (G_OBJECT (renderer), "editable", !column_data->data_locked, NULL);
 		if (g_object_class_find_property (G_OBJECT_GET_CLASS (renderer), "set_default_if_invalid"))
 			g_object_set (G_OBJECT (renderer), "set_default_if_invalid", TRUE, NULL);
-		g_object_set_data (G_OBJECT (renderer), "group", group);
-		g_object_set_data (G_OBJECT (column), "group", group);
+		g_object_set_data (G_OBJECT (renderer), "__gnome_db_group", group);
+		g_object_set_data (G_OBJECT (column), "__gnome_db_group", group);
 
 		/* Adding the GValue's information cell as another GtkCellRenderer */
 		renderer = gnome_db_data_cell_renderer_info_new (grid->priv->store, grid->priv->iter, group);
@@ -680,15 +1093,12 @@
 		g_signal_connect (G_OBJECT (renderer), "status_changed",
 				  G_CALLBACK (data_cell_status_changed), grid);
 		g_object_set (G_OBJECT (renderer), "visible", column_data->info_shown, NULL);
-		g_object_set_data (G_OBJECT (renderer), "group", group);
+		g_object_set_data (G_OBJECT (renderer), "__gnome_db_group", group);
 
 		/* Sorting data */
 		gtk_tree_view_column_set_clickable (column, TRUE);
 		g_signal_connect (G_OBJECT (column), "clicked",
 				  G_CALLBACK (treeview_column_clicked_cb), grid);
-
-		list = g_slist_next (list);
-		i++;
 	}
 }
 
@@ -702,15 +1112,15 @@
 				    GtkTreeModel *tree_model,
 				    GtkTreeIter *iter, GnomeDbRawGrid *grid)
 {
-	GdaSetGroup *group;
+	GnomeDbSetGroup *group;
 	guint attributes;
 	gboolean to_be_deleted = FALSE;
 	ColumnData *column_data;
 
-	group = g_object_get_data (G_OBJECT (tree_column), "group");
+	group = g_object_get_data (G_OBJECT (tree_column), "__gnome_db_group");
 	column_data = get_column_data (grid, group);
 	
-	if (group->nodes_source) {
+	if (group->group->nodes_source) {
 		/* parameters depending on a GdaDataModel */
 		GList *values = NULL;
 		GdaSetSource *source;
@@ -730,9 +1140,9 @@
 		 * external events and we can't know when it has changed.
 		 */
 		attributes = gnome_db_utility_proxy_compute_attributes_for_group (group, grid->priv->store, grid->priv->iter,
-									 iter, &to_be_deleted);
+										  iter, &to_be_deleted);
 		values = gnome_db_utility_proxy_compute_values_for_group (group, grid->priv->store, grid->priv->iter, iter,
-								 TRUE);
+									  TRUE);
 		if (!values) {
 			values = gnome_db_utility_proxy_compute_values_for_group (group, grid->priv->store, 
 									 grid->priv->iter, iter, FALSE);
@@ -773,9 +1183,9 @@
 
 		offset = gda_data_model_get_n_columns (gda_data_proxy_get_proxied_model (grid->priv->proxy));
 
-		g_assert (g_slist_length (group->nodes) == 1);
+		g_assert (g_slist_length (group->group->nodes) == 1);
 		col = g_slist_index (((GdaSet *)grid->priv->iter)->holders,
-				     GDA_SET_NODE (group->nodes->data)->holder);
+				     GDA_SET_NODE (group->group->nodes->data)->holder);
 		gtk_tree_model_get (GTK_TREE_MODEL (grid->priv->store), iter, 
 				    DATA_STORE_COL_TO_DELETE, &to_be_deleted,
 				    DATA_STORE_COL_MODEL_ROW, &row,
@@ -803,22 +1213,22 @@
 				   GtkTreeModel *tree_model,
 				   GtkTreeIter *iter, GnomeDbRawGrid *grid)
 {
-	GdaSetGroup *group;
+	GnomeDbSetGroup *group;
 	guint attributes;
 	gboolean to_be_deleted = FALSE;
 	ColumnData *column_data;
 
-	group = g_object_get_data (G_OBJECT (tree_column), "group");
+	group = g_object_get_data (G_OBJECT (tree_column), "__gnome_db_group");
 	column_data = get_column_data (grid, group);
 	
-	if (group->nodes_source) {
+	if (group->group->nodes_source) {
 		/* parameters depending on a GdaDataModel */
 		GdaSetSource *source;
 
 		source = g_object_get_data (G_OBJECT (tree_column), "source");
 
 		attributes = gnome_db_utility_proxy_compute_attributes_for_group (group, grid->priv->store, grid->priv->iter, 
-									 iter, &to_be_deleted);
+										  iter, &to_be_deleted);
 		g_object_set (G_OBJECT (cell), 
 			      "editable", !column_data->data_locked && !(attributes & GDA_VALUE_ATTR_NO_MODIF),
 			      "value_attributes", attributes,
@@ -836,9 +1246,9 @@
 		
 		offset = gda_data_model_get_n_columns (gda_data_proxy_get_proxied_model (grid->priv->proxy));
 
-		g_assert (g_slist_length (group->nodes) == 1);
+		g_assert (g_slist_length (group->group->nodes) == 1);
 		col = g_slist_index (((GdaSet *)grid->priv->iter)->holders,
-				     GDA_SET_NODE (group->nodes->data)->holder);
+				     GDA_SET_NODE (group->group->nodes->data)->holder);
 		gtk_tree_model_get (GTK_TREE_MODEL (grid->priv->store), iter, 
 				    DATA_STORE_COL_TO_DELETE, &to_be_deleted,
 				    DATA_STORE_COL_MODEL_ROW, &row,
@@ -865,15 +1275,15 @@
 data_cell_value_changed (GtkCellRenderer *renderer, const gchar *path, const GValue *new_value, GnomeDbRawGrid *grid)
 {
 	GtkTreeIter iter;
-	GdaSetGroup *group;
+	GnomeDbSetGroup *group;
 	
-	group = g_object_get_data (G_OBJECT (renderer), "group");
-	g_assert (g_slist_length (group->nodes) == 1);
+	group = g_object_get_data (G_OBJECT (renderer), "__gnome_db_group");
+	g_assert (g_slist_length (group->group->nodes) == 1);
 
 	if (set_iter_from_path (grid, path, &iter)) {
 		    gint col;
 		    col = g_slist_index (((GdaSet *)grid->priv->iter)->holders,
-					 GDA_SET_NODE (group->nodes->data)->holder);
+					 GDA_SET_NODE (group->group->nodes->data)->holder);
 		    gnome_db_data_store_set_value (grid->priv->store, &iter, col, new_value);
 	}
 }
@@ -889,13 +1299,13 @@
 			  GSList *new_values, GSList *all_new_values, GnomeDbRawGrid *grid)
 {
 	GtkTreeIter iter;
-	GdaSetGroup *group;
+	GnomeDbSetGroup *group;
 	
-	group = g_object_get_data (G_OBJECT (renderer), "group");
-	g_assert (group->nodes_source);
+	group = g_object_get_data (G_OBJECT (renderer), "__gnome_db_group");
+	g_assert (group->group->nodes_source);
 
 	if (new_values)
-		g_return_if_fail (g_slist_length (group->nodes) == g_slist_length (new_values));
+		g_return_if_fail (g_slist_length (group->group->nodes) == g_slist_length (new_values));
 	else
 		/* the reason for not having any value is that the GnomeDbDataCellRendererCombo had no selected item */
 		return;
@@ -907,7 +1317,7 @@
 		proxy_row = gnome_db_data_store_get_row_from_iter (grid->priv->store, &iter);
 
 		/* update the GnomeDbDataStore */
-		for (params = group->nodes, list = new_values; 
+		for (params = group->group->nodes, list = new_values; 
 		     list; 
 		     params = params->next, list = list->next) {
 			col = g_slist_index (((GdaSet *)grid->priv->iter)->holders,
@@ -918,13 +1328,13 @@
 #ifdef PROXY_STORE_EXTRA_VALUES
 		/* call gda_data_proxy_set_model_row_value() */
 		gint i;
-		for (i = 0; i < group->nodes_source->shown_n_cols; i++) {
+		for (i = 0; i < group->source->shown_n_cols; i++) {
 			GValue *value;
 
 			col = group->nodes_source->shown_cols_index[i];
 			value = (GValue *) g_slist_nth_data (all_new_values, col);
 			gda_data_proxy_set_model_row_value (grid->priv->proxy,
-							    group->nodes_source->data_model,
+							    group->group->nodes_source->data_model,
 							    proxy_row, col, value);
 		}
 #endif
@@ -952,13 +1362,13 @@
 static void
 treeview_column_clicked_cb (GtkTreeViewColumn *tree_column, GnomeDbRawGrid *grid)
 {
-	GdaSetGroup *group;
+	GnomeDbSetGroup *group;
 	GSList *nodes;
 
-	group = g_object_get_data (G_OBJECT (tree_column), "group");
+	group = g_object_get_data (G_OBJECT (tree_column), "__gnome_db_group");
 	g_assert (group);
 
-	for (nodes = group->nodes; nodes; nodes = nodes->next) {
+	for (nodes = group->group->nodes; nodes; nodes = nodes->next) {
 		GdaHolder *param = ((GdaSetNode*) nodes->data)->holder;
 		gint pos;
 		g_assert (param);
@@ -980,7 +1390,7 @@
 {
 	GtkTreePath *treepath;
 	GtkTreeIter iter;
-	GdaSetGroup *group;
+	GnomeDbSetGroup *group;
 	GtkTreeModel *tree_model;
 	gint col;
 	gint offset;
@@ -988,7 +1398,7 @@
 
 	offset = gda_data_model_get_n_columns (gda_data_proxy_get_proxied_model (grid->priv->proxy));
 
-	group = g_object_get_data (G_OBJECT (renderer), "group");
+	group = g_object_get_data (G_OBJECT (renderer), "__gnome_db_group");
 	tree_model = GTK_TREE_MODEL (grid->priv->store);
 
 	treepath = gtk_tree_path_new_from_string (path);
@@ -1000,13 +1410,13 @@
 	gtk_tree_path_free (treepath);
 	
 	g_value_set_uint (attribute = gda_value_new (G_TYPE_UINT), requested_action);
-	if (group->nodes_source) {
+	if (group->group->nodes_source) {
 		/* parameters depending on a GdaDataModel */
 		gint proxy_row;
 		GSList *list;
 		proxy_row = gnome_db_data_store_get_row_from_iter (grid->priv->store, &iter);
 
-		for (list = group->nodes; list; list = list->next) {
+		for (list = group->group->nodes; list; list = list->next) {
 			col = g_slist_index (((GdaSet *)grid->priv->iter)->holders,
 					     GDA_SET_NODE (list->data)->holder);
 			gnome_db_data_store_set_value (grid->priv->store, &iter, offset + col, attribute);
